/' Program: Blending.bas '/
#lang "fb"

#include "../../bglBase2D.bi"
#include "../../bglTextures.bi"

Type _
  TBlending Extends TGLBase2D
    Private :
      Tex As TGLTextures
      Tex1 As TTexture
      Tex2 As TTexture
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TBlending

  App.MainLoop ()

Constructor TBlending ()
  Create (,, "Stormy :: Blending Funktionen")
  
  Tex.CreateTextureFromFile ("../data/blending1.jpg", "tex1")
  Tex.CreateTextureFromFile ("../data/blending2.png", "tex2")

  Tex1= Tex.GetID (Tex.GetIndex ("tex1"))
  Tex2= Tex.GetID (Tex.GetIndex ("tex2"))
End Constructor

Sub TBlending.DrawScene ()
  glClearColor (0,0,0,0)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  '' Hier kommt der OpenGL Code rein

  glLoadIdentity ()
  glTranslatef (100,100,0)

  ''Blending aktivieren, Hintergrund belassen zum Pfaden Alpha-Wert nehmen
  glEnable (GL_BLEND)
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
  glColor4f (1,1,1,0.5)

  glDisable (GL_DEPTH_TEST)

  glBindTexture (GL_TEXTURE_2D, Tex1)	' Texture binden
  glBegin (GL_QUADS)
    glTexCoord2f (0, 0)
    glVertex2i  (0, 128)    '' LINKS UNTEN  (1. Koordinate)
    glTexCoord2f (1, 0)
    glVertex2i (128, 128)    '' RECHTS UNTEN (2. Koordinate)
    glTexCoord2f (1, 1)
    glVertex2i (128,  0)    '' RECHTS OBEN  (3. Koordinate)
    glTexCoord2f (0, 1)
    glVertex2i  (0,  0)    '' LINKS OBEN   (4. Koordinate)
  glEnd ()

  glBindTexture (GL_TEXTURE_2D, Tex2)	' Texture binden
  glBegin (GL_QUADS)
    glTexCoord2f (0, 0)
    glVertex2i  (0, 128)    '' LINKS UNTEN  (1. Koordinate)
    glTexCoord2f (1, 0)
    glVertex2i (128, 128)    '' RECHTS UNTEN (2. Koordinate)
    glTexCoord2f (1, 1)
    glVertex2i (128,  0)    '' RECHTS OBEN  (3. Koordinate)
    glTexCoord2f (0, 1)
    glVertex2i  (0,  0)    '' LINKS OBEN   (4. Koordinate)
  glEnd ()

  glEnable (GL_DEPTH_TEST)
  glBindTexture (GL_TEXTURE_2D, 0) '' texture bindung loessen !?

End Sub
