/' Program: Clipping.bas '/
#lang "fb"

#include "../../bglBase2D.bi"
#include "../../bglTextures.bi"
#include "../../glUtils.bi"

Type _
  TClipping Extends TGLBase2D
    Private :
      Tex As TGLTextures
      Texture As TTextureInfo
      MyPlayer AS TPlayer
      As TCoordsTex health_empty, health_full, shield_empty, shield_full,_
         rockets_active, rockets_inactive
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TClipping

  App.MainLoop ()

Constructor TClipping ()
  Create (,, "Clipping")
  
  Texture= Tex.GetInfo (Tex.CreateTextureFromFile ("../data/space_hud.tga", "spaceHud"))

  With MyPlayer
    .health_current = 100
    .health_max = 100
    .shield_current = 50
    .shield_max = 250
    .rockets_current = 2
    .rockets_max = 5
  End With

  With shield_empty
    .X1 = 0: .Y1 = 0:  .X2 = 254: .Y2 = 46
  End With

  With shield_full
    .X1 = 0: .Y1 = 46:  .X2 = 254: .Y2 = 92
  End With

  With health_empty
    .X1 = 0: .Y1 = 92:  .X2 = 254: .Y2 = 138
  End With

  With health_full
    .X1 = 0: .Y1 = 138:  .X2 = 254: .Y2 = 184
  End With

  With rockets_active
    .X1 = 0: .Y1 = 207 :  .X2 = 24: .Y2 = 254
  End With

  With rockets_inactive
    .X1 = 25: .Y1 = 207:  .X2 = 49: .Y2 = 254
  End With
End Constructor

Sub TClipping.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  glColor3f (1,1,1)
  With health_empty
   PutClip (texture, 20, 400, 0, .X1, .Y1, .X2, .Y2)
  End With
  With health_full
   PutClip (texture, 20, 400, 1, .X1, .Y1, .X1 + _
   (255*(MyPlayer.health_current/MyPlayer.health_max)), .Y2)
  End With
  With shield_empty
   PutClip (texture, 280, 400, 0, .X1, .Y1, .X2, .Y2)
  End With
  With shield_full
   PutClip (texture, 280, 400, 1, .X1, .Y1, .X1 + _
   (255*(MyPlayer.shield_current/MyPlayer.shield_max)), .Y2)
  End With

  For r As Integer= 1 To MyPlayer.rockets_max
    If(MyPlayer.rockets_current >= r) Then
      With rockets_active
        PutClip (texture, 10+(r-1)*50, 10, 0, .X1, .Y1, .X2, .Y2)
      End With
    Else
      With rockets_inactive
        PutClip (texture, 10+(r-1)*50, 10, 0, .X1, .Y1, .X2, .Y2)
      End With
    End If
  Next r

  If Key(kbUP) Then
    If(MyPlayer.rockets_current < MyPlayer.rockets_max) Then
      MyPlayer.rockets_current += 1
    End If
  END IF

  If Key(kbDOWN) Then
    If(MyPlayer.rockets_current > 0) Then
      MyPlayer.rockets_current -= 1
    End If
  End If

  If Key(kbRIGHT) Then
    If(MyPlayer.health_current < MyPlayer.health_max) Then
     MyPlayer.health_current+=1
    Else
      If(MyPlayer.shield_current < MyPlayer.shield_max) Then
        MyPlayer.shield_current+=1
      End If
    End If
  End If

  If Key(kbLEFT) Then
    If(MyPlayer.shield_current > 0) Then
      MyPlayer.shield_current-=1
    Else
      If(MyPlayer.health_current > 0) Then
        MyPlayer.health_current-=1
      End If
    End If
  End If

  glFlush ()
End Sub
