/' Program: Font.bas '/
#lang "fb"

#include "../../bglBase2D.bi"
#include "../../glUtils.bi"

Type _
  TBouncingText Field= 1
    As String Text
    As Integer R, G, B
    As Integer posX, posY
    As Integer dirX, dirY
    As Integer w
  End Type

Type _
  TFont Extends TGLBase2D
    Private :
      MyFont As TFontSystem
      MyText(1 To 5) As TBouncingText
      r As Integer
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
      Declare Sub HandleKeyPress (ByRef Event As TEvent) Override
      Declare Virtual Destructor ()
  End Type

Dim App As TFont

  App.MainLoop ()

Constructor TFont ()
  Randomize (Timer)
  Create (,, "Font")

  MyFont.Spacing= 2
  FontLoad (MyFont, "../data/standard.tga","data/standard.dat")

  For e As Integer= 1 To 5
    With MyText(e)
      .text= "Example text #" + Str (e)
      .w= FontGetWidth (MyFont, .text)
      .posX= Int (Rnd* ScreenWidth- .w)+ 1
      .posY= Int (Rnd* ScreenHeight- 16)+ 1
      .dirX= Int (Rnd* 6)- 3
      .dirY= Int (Rnd* 6)- 3
      .R= Int (Rnd* 128)+ 128
      .G= Int (Rnd* 128)+ 128
      .B= Int (Rnd* 128)+ 128
    End With
  Next e
End Constructor

Sub TFont.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  For x As Integer= 0 To Fix (ScreenWidth/ 16)
    For y As Integer= 0 To Fix (ScreenHeight/ 16)
      r= Int (Rnd* 50)+ 40
      glPrint (MyFont, Str(Int (Rnd* 2)), x* 16, y* 16, 0, r, r, r)
    Next y
  Next x

  For e As Integer= 1 To 5
    With MyText(e)
      glPrint (MyFont, .text, .posX, .posY, 1, .R, .G, .B)
      If(.posX + .w >= ScreenWidth) Then .dirX= .dirX* -1
      If(.posY + 16 >= ScreenHeight) Then .dirY= .dirY* -1
      IF(.posX <= 0) Then .dirX= .dirX* -1
      If(.posY <= 0) Then .dirY= .dirY* -1
      .posX+= .dirX
      .posY+= .dirY
    End With
  Next e
  
  glFlush ()
End Sub

Sub TFont.HandleKeyPress (ByRef Event As TEvent)
  Base.HandleKeyPress (Event)

  Select Case Event.ScanCode
    Case kbR
      For I As Integer= 1 To 5
        With MyText(I)
          .posX= Int (Rnd* ScreenWidth- .w)+ 1
          .posY= Int (Rnd* ScreenHeight- 16)+ 1
          .dirX= Int (Rnd* 6)- 3
          .dirY= Int (Rnd* 6)- 3
          .R= Int (Rnd* 128)+ 128
          .G= Int (Rnd* 128)+ 128
          .B= Int (Rnd* 128)+ 128
        End With
      Next I
  End Select
End Sub

Destructor TFont ()
  DestroyFont (MyFont)
End Destructor
