/' Program: Light2.bas '/
#lang "fb"

#include "../../bglBase2D.bi"
#include "../../glUtils.bi"
#include "../../bglTextures.bi"

Type _
  TLight Field= 1
    As Integer R, G, B, A
    As Single X, Y, dirX, dirY
    As Integer w
  End Type

Type _
  TLight2 Extends TGLBase2D
    Private :
      Tex As TGLTextures
      As TTextureInfo light_texture, background_texture
      MyLight(1 To 5) As TLight
      
      Declare Sub Init ()
    Public :
      Declare Constructor ()
      Declare Sub HandleKeyPress (ByRef Event As TEvent) Override
      Declare Sub DrawScene () Override
  End Type

Dim App As TLight2

  App.MainLoop ()

Sub TLight2.Init ()
  For e As Integer= 1 To 5
    With MyLight(e)
      .w= Int (Rnd* 256)+ 128
      .X= Int (Rnd* ScreenWidth)+ 1
      .Y= Int (Rnd* ScreenHeight)+ 1
      .R= Int (Rnd* 128)+ 128
      .G= Int (Rnd* 128)+ 128
      .B= Int (Rnd* 128)+ 128
      .A= Int (Rnd* 128)+ 128
      .dirX= Int (Rnd* 6)- 3
      .dirY= Int (Rnd* 6)- 3
    End With
  Next e
End Sub

Constructor TLight2 ()
  Randomize (Timer)
  Create (,, "Light #2")

  Init ()

  light_texture= Tex.GetInfo (Tex.CreateTextureFromFile ("../data/light.tga", "light_texture"))
  background_texture= Tex.GetInfo (Tex.CreateTextureFromFile ("../data/brick.tga", "background_texture"))

  glEnable (GL_BLEND)
End Constructor

Sub TLight2.HandleKeyPress (ByRef Event As TEvent)
  Base.HandleKeyPress (Event)
  
  Select Case Event.ScanCode
    Case kbR
      Init ()
  End Select

End Sub

Sub TLight2.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  glcolor4f (.5,.5,.5,1)
  glDepthFunc (GL_LESS)
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)

  For x As Integer= 0 To Fix (ScreenWidth/ background_texture.TexWidth)
    For y As Integer= 0 To Fix (ScreenHeight/ background_texture.TexHeight)
      PutTexture (background_texture,_
                  x* background_texture.TexWidth,_
                  y* background_texture.TexHeight, 0)
    Next y
  Next x

  glDepthFunc (GL_ALWAYS)
  glBlendFunc (GL_SRC_ALPHA, GL_SRC_ALPHA)
  For e As Integer= 1 To 5
    With MyLight(e)
      glcolor4ub .R, .G, .B, 255
      glBindTexture (GL_TEXTURE_2D, light_texture.TexID)
      DrawTexQuad (.X, .Y, 2, .w, .w)

      If(.X + .w / 2 >= ScreenWidth) Then .dirX= .dirX* -1
      If(.Y + .w / 2 >= ScreenHeight) Then .dirY= .dirY* -1
      If(.X + .w / 2 <= 0) Then .dirX= .dirX* -1
      If(.Y + .w / 2 <= 0) Then .dirY= .dirY* -1
   
      .X += .dirX
      .Y += .dirY

    End With
  Next e

  glDepthFunc (GL_LESS)
  glBlendFunc (GL_DST_COLOR, GL_DST_COLOR)
  glcolor4f (0,0,0,1)
  glBindTexture (GL_TEXTURE_2D, 0)
  PutBox (0, 0, ScreenWidth, ScreenHeight, 3)

  glFlush ()
End Sub
