/' Program: ScalRotate.bas '/
#lang "fb"

#include "../../bglBase2D.bi"
#include "../../bglTextures.bi"

Type _
  TScalRotate Extends TGLBase2D
    Private :
      Tex As TGLTextures
      texture As TTexture
      MidX As Integer
      MidY As Integer
      W As Integer
      H As Integer
      Change As Integer
      Rot As Single
      Scal As Single
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TScalRotate

  App.MainLoop ()

Constructor TScalRotate ()
  Create ()
  
' Finde Mittelpunkt
  MidX= ScreenWidth\ 2
  MidY= ScreenHeight\ 2
  
  W= 64: H= 64
  Rot= 0
  Scal= 1
  texture= Tex.GetID (Tex.CreateTextureFromFile ("../data/eagle.tga", "eagle",, True))
End Constructor

Sub TScalRotate.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  glColor3f (1,1,1)
    glTranslatef (MidX, MidY, 0)
    glscalef (Scal, Scal, 1)
    glrotatef (Rot, 0, 0, 1)
	
  glBegin (GL_QUADS)
		glTexCoord2f (0.0, 0.0) ' links unten
		glVertex2i   (-W/ 2, H/ 2)
		glTexCoord2f (1.0, 0.0) ' rechts unten
		glVertex2i   (W/ 2, H/ 2)
		glTexCoord2f (1.0, 1.0) ' rechts oben
		glVertex2i   (W/ 2, -H/ 2)
		glTexCoord2f (0.0, 1.0) ' links oben
		glVertex2i   (-W/ 2, -H/ 2)
	glEnd ()
     glLoadIdentity ()

  glFlush ()
  change = 0
  IF Key(kbUP) Then
    Scal+=.05
    Change = 1
  End If
  If Key(kbDOWN) Then
    Scal-= .05
    Change= 1
    IF(Scal <= .1) Then
      Scal=.05
    End If
  End If

  If Key(kbRIGHT) Then
    Rot+= 5
    Change= 1
  End If
  
  IF Key(kbLEFT) Then
    Rot-= 5
    Change= 1
  End If

  If(Change = 1) Then
    WindowTitle ("[ Rotation & Scale ] scale factor: "_
                + Str (Scal) + " rotation degree: " + Str (Rot) )
  End If
End Sub
