/' Program: Shadow2.bas '/
#lang "fb"

#include "../../bglBase2D.bi"
#include "../../glUtils.bi"
#include "../../bglTextures.bi"

Type _
  TShadow Extends TGLBase2D
    Private :
      As TGLTextures Tex
      As TTextureInfo texture, background_texture
      As Integer X, Y
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TShadow

  App.MainLoop ()

Constructor TShadow ()
  Create (,, "Shadow #2")
  
  texture= Tex.GetInfo (Tex.CreateTextureFromFile ("../data/horse.tga", "texture"))
  background_texture= Tex.GetInfo (Tex.CreateTextureFromFile ("../data/grass.tga", "background_texture"))
  
  X= 150
  Y= 0
  glEnable GL_BLEND						' Blending erlauben
End Constructor

Sub TShadow.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  ' Zeichne Untergrund

  For bx As Integer= 0 To Fix (ScreenWidth/ background_texture.TexWidth)
    For by As Integer= 0 To Fix (ScreenHeight/ background_texture.TexHeight)
      PutTexture (background_texture,_
      bx* background_texture.TexWidth,_
      by* background_texture.TexHeight, 0)
    Next by
  Next bx

  ' Schattenabbild
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
  glColor4ub (0,0,0,128)
  glBindTexture (GL_TEXTURE_2D, texture.TexID)
  DrawTexQuad (x+ 75, y+ 120, 2, texture.TexWidth* 0.75, texture.TexHeight* 0.75)
  ' Original
  glColor3ub (255,255,255)
  'glBindTexture (GL_TEXTURE_2D, texture->TexID)
  DrawTexQuad (x, y, 3, texture.TexWidth, texture.TexHeight)

  'PutTexture (texture, x, y, 10) ' Figur

  If Key(kbLEFT) Then x- =1
  If Key(kbRIGHT) Then x+ =1
  If Key(kbUP) Then y-= 1
  If Key(kbDOWN) Then y+= 1

  glFlush ()
End Sub
