/' Program: Mirror.bas '/
#lang "fb"

#include "../../bglBase2D.bi"
#include "../../bglTextures.bi"
#include "../../glUtils.bi"

Type _
  TMirror Extends TGLBase2D
    Private :
      Tex As TGLTextures
      Texture As TTextureInfo
      X As Integer
      Y As Integer
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TMirror

  App.MainLoop ()

Constructor TMirror ()
  Create (,, "Mirror")
  Texture= Tex.GetInfo (Tex.CreateTextureFromFile ("../data/horse.tga", "horse")) ' Lade eine Textur
  X= 150
  Y= 0
End Constructor

Sub TMirror.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  '' Zeichne Untergrund

  glDepthfunc (GL_LESS)		 ' Standard-Tiefentest
  glDisable (GL_BLEND)		 ' Kein Blend-Modus

  glBindTexture (GL_TEXTURE_2D, 0) ' Löse Textur, da wir farbige Objekte
  				                         ' ohne Textur zeichnen wollen.

  glColor3ub (19, 160, 0)		 ' Grüne Wiese
  PutBox (1, 200, 640, 460, 1)

  glColor3ub (0, 16, 160)		 ' Wasserfläche
  PutBox (150, 230, 480, 460, 2)

  glColor3ub (255, 255, 255)
  PutTexture (Texture, X, Y, 10) ' Figur
  ' Zeichne Spiegelung
  glDepthfunc (GL_EQUAL)	 ' Tiefentest: Gleiche Ebene
  glEnable (GL_BLEND)
  				 ' Unser schöner Blendmodus für Transparenz
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)

  glColor4f (1, 1, 1, .5)		 ' Zeichne verkehrte Figur
  PutTextureVert (Texture, X, Y+ Texture.TexHeight, 2)

  If Key(FB.SC_LEFT) Then x-=1
  If Key(FB.SC_RIGHT) Then x+=1
  If Key(FB.SC_UP) Then y-=1
  If Key(FB.SC_DOWN) Then y+=1

  glFlush ()
End Sub
