/' program: lesson4_3.bas '/
#lang "fb"

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Type _
  TMyProgram Extends TGLBase3D
    Private :
      As Single x, outrot
      As TGLTextures Tex
      As Integer texture1, texture2
      
      Declare Sub DrawPyramid ()
    Public :
      Declare Constructor ()
      Declare Sub UpdateWorld (ByVal Seconds As GLFloat) Override
      Declare Sub DrawScene () Override
      Declare Virtual Destructor ()
  End Type

Dim MyProgram As TMyProgram

  MyProgram.MainLoop ()

Constructor TMyProgram ()
  Create ()
  HideMouse ()
  texture1= Tex.CreateTextureFromFile ("../../gfx/wall.jpg", "wall")
  texture2= Tex.CreateTextureFromFile ("../../gfx/energy.jpg", "energy")
  
End Constructor

Sub TMyProgram.UpdateWorld (ByVal Seconds As GLFloat)
'' "Berechnung" der Szene
  x= x+ 60* Seconds
  outrot= outrot+ 120* Seconds
End Sub

Sub TMyProgram.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  '' Kleine Pyramide in der Mitte
  glBindTexture (GL_TEXTURE_2D, Tex.GetID (texture1))
  glLoadIdentity ()
  glTranslatef (0,0,-14)

  glPushMatrix ()
  glTranslatef (0,sin(x/50),0)
  glRotatef (x,0,1,0)

  glMatrixMode (GL_TEXTURE)
    glLoadIdentity ()
    glColor3f (1,1,1)
    glTranslatef (0,-(x/100),0)
  glMatrixMode(GL_MODELVIEW)

  DrawPyramid ()
  glPopMatrix ()

  '' Gre mittlere Pyramide
  glBindTexture(GL_TEXTURE_2D, Tex.GetID (texture2))

/'NEU! : Alpha blending aktivieren '/
  glEnable (GL_BLEND)                  '' Aktivieren von Alpha Blending
  glBlendFunc (GL_SRC_ALPHA, GL_ONE)   '' Definiert die Art, wie bergeblendet werden soll
  glDisable (GL_DEPTH_TEST)            '' Z-Buffer deaktivieren

  glPushMatrix ()
  glRotatef (x,0,1,0)
  glScalef (2,2,2)

  If(Sin (x/50) < 0.9) Then
    glColor4f (1,1,1,0.4)
  Else
    glColor4f (1,0.3,0.3,0.5)
  End If

  DrawPyramid ()
  glPopMatrix ()

  '' Blaue uere Pyramide
  glPushMatrix ()
  glColor4f (0.3,0.3,0.8,0.8)
  glRotatef (outrot,0,1,0)
  glTranslatef (5,0,0)
  glRotatef (outRot,-0.5,1,0)
  DrawPyramid ()
  glPopMatrix ()

  '' Grne uere Pyramid
  glPushMatrix ()
  glColor4f (0.3,0.8,0.3,0.8)
  glRotatef (outrot,0,1,0)
  glTranslatef (-5,0,0)
  glRotatef (OutRot,0.5,1,0)
  DrawPyramid ()
  glPopMatrix ()

/'NEU! : Alpha blending deaktivieren '/
    glDisable (GL_BLEND)                 '' Alpha blending deaktivieren
    glEnable (GL_DEPTH_TEST)             '' Z-Buffer an
End Sub

Sub TMyProgram.DrawPyramid ()
  glBegin (GL_TRIANGLES)
    ''left
    glTexCoord2f (0.0, 0.0): glVertex3f (-1.0, -1.0, -1.0)
    glTexCoord2f (1.0, 0.0): glVertex3f (-1.0, -1.0,  1.0)
    glTexCoord2f (1.0, 1.0): glVertex3f (   0,  1.0,    0)

    ''right
    glTexCoord2f (0.0, 0.0): glVertex3f ( 1.0, -1.0, -1.0)
    glTexCoord2f (1.0, 0.0): glVertex3f ( 1.0, -1.0,  1.0)
    glTexCoord2f (1.0, 1.0): glVertex3f (   0,  1.0,    0)

    ''front
    glTexCoord2f (0.0, 0.0): glVertex3f (-1.0, -1.0,  1.0)
    glTexCoord2f (1.0, 0.0): glVertex3f ( 1.0, -1.0,  1.0)
    glTexCoord2f (1.0, 1.0): glVertex3f ( 0.0,  1.0,  0.0)

    ''back
    glTexCoord2f (0.0, 0.0): glVertex3f (-1.0, -1.0, -1.0)
    glTexCoord2f (1.0, 0.0): glVertex3f ( 1.0, -1.0, -1.0)
    glTexCoord2f (1.0, 1.0): glVertex3f ( 0.0,  1.0,  0.0)
    glEnd ()
End Sub

Destructor TMyProgram ()  
  ShowMouse ()
End Destructor
