/' program: lesson4_4.bas '/
#lang "fb"

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Const _
  MAP_WIDTH = 10, _
  MAP_HIGHT = 30

Type _
  TMyProgram Extends TGLBase3D
    Private :
      Tex As TGLTextures
      texture As TTexture
      MAP(0 To MAP_WIDTH+ 1, 0 To MAP_HIGHT+ 1) As Single
      z As Single
      
      Declare Sub InitMap ()
    Public :
      Declare Constructor ()    
      Declare Sub UpdateWorld (ByVal Seconds As GLFloat) Override
      Declare Sub DrawScene () Override
      Declare Virtual Destructor ()
  End Type

Dim MyProgram As TMyProgram

  MyProgram.MainLoop ()

Constructor TMyProgram ()
  Create (800, 600)
  
  texture= Tex.GetID (Tex.CreateTextureFromFile ("../../gfx/venus.jpg", ""))
  
  Randomize (Timer)
  InitMap ()
End Constructor

Sub TMyProgram.UpdateWorld (ByVal Seconds As GLFloat)
'' "Berechnung" der Szene
  z= z- 0.8* Seconds
End Sub

Sub TMyProgram.DrawScene ()
Dim As Single u, v

  glClearColor (0.8,0.8,1,1)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  glLoadIdentity ()
  gluLookAt( (MAP_WIDTH/ 2),2,5, _
             (MAP_WIDTH/2),2,0, _
              0,1,0)
  glPushMatrix ()
  u= 1/ MAP_WIDTH
  v= 1/ MAP_HIGHT
  glNormal3f (0.0, 1.0, 0.0)
  
  glTranslatef (0,0,-z)
  
  For y As Integer= 0 To MAP_HIGHT- 1
    glPushMatrix ()
    For x As Integer= 0 To MAP_WIDTH- 1
      glBegin (gl_QUADS)
        glTexCoord2f (u*x    , v*(y+1)): glVertex3f(0, map(x,y+1)  , 0)
        glTexCoord2f (u*x    , v*y    ): glVertex3f(0, map(x,y)    , 1)
        glTexCoord2f (u*(x+1), v*y    ): glVertex3f(1, map(x+1,y)  , 1)
        glTexCoord2f (u*(x+1), v*(y+1)): glVertex3f(1, map(x+1,y+1), 0)
      glEnd ()
      glTranslatef (1,0,0)
    Next x
    glPopMatrix ()
    glTranslatef (0,0,-1)
  Next y
  glPopMatrix ()
End Sub

Sub TMyProgram.InitMap ()
  For x As Integer= 0 To MAP_WIDTH+ 1
    For y As Integer= 0 To MAP_HIGHT+ 1
      Map(x, y)= 0.01* Rnd* 50
    Next y
  Next x
End Sub

Destructor TMyProgram ()
  glDeleteTextures (1, @texture)
End Destructor
