/' program: lesson4_5.bas '/
#lang "fb"

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Type _
  TMyProgram Extends TGLBase3D
    Private :
      Tex As TGLTextures
      texture As TTexture
      pic As Single
    Public :
      Declare Constructor ()
      Declare Sub UpdateWorld (ByVal Seconds As GLFloat) Override
      Declare Sub DrawScene () Override
  End Type

Dim MyProgram As TMyProgram
  
  MyProgram.MainLoop ()

Constructor TMyProgram ()
  Create ()
  
  texture= Tex.GetID (Tex.CreateTextureFromFile ("../../gfx/numbers.jpg", ""))
End Constructor

Sub TMyProgram.UpdateWorld (ByVal Seconds As GLFloat)
  pic= pic+ Seconds      '' Geschwindigkeit (in dem Fall Bilder pro Sekunde)
End Sub

Sub TMyProgram.DrawScene ()
Dim s As Single

  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  glLoadIdentity ()
  glTranslatef (0,-2,-10)

  glBindTexture (GL_TEXTURE_2D, texture)     '' Texture setzen


  s= 1/ 8 /' Berechnung der Bildgre. In diesem Fall besteht das Bild aus 8 Bildern,
              beim UV-Mapping ist das Maximum 1, d.h. 1/8 = 0.125. D.h.
              0 - 0.125      #Bild 1
              0.125 - 0.250  #Bild 2
              etc
          '/
                        
  /' Wir berechnen das UV-Mapping jedesmal neu. Grob behalten wir immer die Gre 1/8, scrollen,
    die Texture, aber praktisch Schritt fr Schritt, so dass diese langsam auf dem Screen
    lngs scrollt
  '/
  glBegin (GL_QUADS)
    glTexCoord2f (pic*s,1): glVertex3f (-1,1,0)
    glTexCoord2f (pic*s+s,1): glVertex3f (1,1,0)
    glTexCoord2f (pic*s+s,0): glVertex3f (1,-1,0)
    glTexCoord2f (pic*s,0): glVertex3f (-1,-1,0)
  glEnd ()

  /' Ein Interessantes Beispiel dafr, das die richtigen Zahlen sehr wichtig sein
    knnen. Wir runden unsere Werte hier einfach, d.h. wir erreichen nur volle Bildteiel
    1/8*x. Da x nur ganzzahlig ist, gibt es kein flssige Animation, sondern ein "umblenden".
  '/

  glTranslatef (0,3,0)
  glBegin (GL_QUADS)
    glTexCoord2f (cInt(pic)*s,1): glVertex3f (-1,1,0)
    glTexCoord2f (cInt(pic)*s+s,1): glVertex3f (1,1,0)
    glTexCoord2f (cInt(pic)*s+s,0): glVertex3f (1,-1,0)
    glTexCoord2f (cInt(pic)*s,0): glVertex3f (-1,-1,0)
  glEnd ()
End Sub
