/' Program: asteroids.bas '/
#lang "fb"

/'
{******************************************************************************}
{                                                                              }
{       Borland Delphi Runtime Library                                         }
{                                                                              }
{ Copyright (C)  Florian Sievert(Phobeus)                                      }
{   converted to VCL by Nico Michaelis(Delphic)                                }
{ All Rights Reserved.                                                         }
{                                                                              }
{       Obtained through:                                                      }
{       Delphi OpenGL Community(DGL)                                           }
{                                                                              }
{ You may retrieve the latest version of this file at the Delphi OpenGL        }
{ Community home page, located at http://www.delphigl.com/                     }
{                                                                              }
{ The contents of this file are used with permission, subject to               }
{ the Mozilla Public License Version 1.1 (the "License"); you may              }
{ not use this file except in compliance with the License. You may             }
{ obtain a copy of the License at                                              }
{ http://www.mozilla.org/MPL/MPL-1.1.html                                      }
{                                                                              }
{ Software distributed under the License is distributed on an                  }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or               }
{ implied. See the License for the specific language governing                 }
{ rights and limitations under the License.                                    }
{                                                                              }
{******************************************************************************}
'/

#include "../../bglBase3D.bi"
#include "Asteroid_data.inc"
#include "../../bglTextures.bi"

Const _
  Max_Asteroids = 50

'' Asteroiden Infos
Type _
  TAsteroid Field= 1
    As Single  x,  y,  z, _
              rx, ry, rz, _
              sx, sy, sz
  End Type

Type _
  TAsteroids Extends TGLBase3D
    Private :
      Tex As TGLTextures
      Venus As TTexture
      Asteroid As gluInt                         '' Name fr Display-Liste
      rocks(0 To Max_Asteroids) As TAsteroid     '' Infos der Asteroids

      Declare Sub InitAsteroids ()
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
      Declare Virtual Destructor ()
  End Type

Dim Asteroids As TAsteroids

  Asteroids.MainLoop ()

Constructor TAsteroids ()
  Create (800, 600)
  HideMouse ()
  Randomize (Timer)
  InitAsteroids ()
End Constructor

Sub TAsteroids.InitAsteroids ()
Dim c As Integer

  Venus= Tex.GetID (Tex.CreateTextureFromFile ("texture/venus.bmp", ""))

  '' Display-Liste erstellen
  asteroid= glGenLists (1)
  glBindTexture (GL_TEXTURE_2D, Venus)
  glNewList (asteroid, GL_COMPILE)
  glscalef (0.02,0.02,0.02)

  '' Rendern der Asteroid-Data
  glBegin (GL_TRIANGLES)
  For c= 0 To vindices- 1
    glTexCoord2fv (@texdata(texindex(c, 0), 0))
    glvertex3fv (@vertexdata(vertexindex(c, 0), 0))

    glTexCoord2fv (@texdata(texindex(c, 1), 0))
    glvertex3fv (@vertexdata(vertexindex(c, 1), 0))

    glTexCoord2fv (@texdata(texindex(c, 2), 0))
    glvertex3fv (@vertexdata(vertexindex(c, 2), 0))
  Next c

  glEnd ()
  glEndList ()

  '' Erzeugen von zuflligen Rotations-Geschwindigkeiten
  For c= 0 To Max_Asteroids
    With rocks(c)
      .x= Rnd* 20- 10
      .y= Rnd* 20- 10
      .z= Rnd* 100

      .sx= Rnd* 2
      .sy= Rnd* 2
      .sz= Rnd* 2
    End With
  Next c

End Sub

Sub TAsteroids.DrawScene ()
Dim c As Integer

  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  glPushMatrix ()
  
  glEnable (GL_TEXTURE_2D)
  glBindTexture (GL_TEXTURE_2D, Venus)

  glTranslatef (0,0,-100)

  '' Zeichnen der Asteroiden
  For c= 0 To Max_Asteroids
    '' Rotieren der Asteroiden
    rocks(c).rx= rocks(c).rx+ rocks(c).sx
    rocks(c).ry= rocks(c).ry+ rocks(c).sy
    rocks(c).rz= rocks(c).rz+ rocks(c).sz

    ''Erstellen der Matrix
    glPushMatrix ()
      '' Transformieren
      gltranslatef (rocks(c).x, rocks(c).y, rocks(c).z)
      glRotatef (rocks(c).rx, 1,0,0)
      glRotatef (rocks(c).ry, 0,1,0)
      glRotatef (rocks(c).rz, 0,0,1)

      '' Rendern
      glCallList (asteroid)
    glPopMatrix ()
  Next c
  
  glPopMatrix ()
End Sub

Destructor TAsteroids ()
  glDeleteLists (asteroid, vindices)
  
  ShowMouse ()
End Destructor
