/' Program: culling.bas '/
#lang "fb"

/'
{******************************************************************************}
{                                                                              }
{       Borland Delphi Runtime Library                                         }
{                                                                              }
{ Copyright (C)  Florian Sievert(Phobeus)                                      }
{   converted to VCL by Nico Michaelis(Delphic)                                }
{ All Rights Reserved.                                                         }
{                                                                              }
{       Obtained through:                                                      }
{       Delphi OpenGL Community(DGL)                                           }
{                                                                              }
{ You may retrieve the latest version of this file at the Delphi OpenGL        }
{ Community home page, located at http://www.delphigl.com/                     }
{                                                                              }
{ The contents of this file are used with permission, subject to               }
{ the Mozilla Public License Version 1.1 (the "License"); you may              }
{ not use this file except in compliance with the License. You may             }
{ obtain a copy of the License at                                              }
{ http://www.mozilla.org/MPL/MPL-1.1.html                                      }
{                                                                              }
{ Software distributed under the License is distributed on an                  }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or               }
{ implied. See the License for the specific language governing                 }
{ rights and limitations under the License.                                    }
{                                                                              }
{******************************************************************************}
'/

#include "../../bglBase3D.bi"

Type _
  TCulling Extends TGLBase3D
    Private :
      Culling As Boolean
    Public :
      Declare Sub HandleKeyPress (ByRef Event As TEvent) Override
      Declare Sub DrawScene () Override
  end Type

Dim Culling As TCulling

  Culling.Create ()
  Culling.MainLoop ()

Sub TCulling.HandleKeyPress (ByRef Event As TEvent)
  Base.HandleKeyPress (Event)

  If(Event.ScanCode = FB.SC_SPACE) Then
    Culling= Not Culling
  End If

  '' Culling an, aus
  If Culling Then
    glEnable (GL_CULL_FACE)
  Else
    glDisable (GL_CULL_FACE)
  End If
  
End Sub

Sub TCulling.DrawScene ()
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  
  glPushMatrix ()
  glTranslatef (0,0,-5)
  
  '' Bei aktivierten Culling bleibt dieses Quad erhalten, weil es die
  '' Vorderseite ist.
  '' TIP: glCullFace(GL_FRONT); wrde die Vorderseite, statt der Rckseite entfernen!
  glPushMatrix ()
  glTranslatef (-1,0,0)
  glBegin (GL_QUADS)
    glColor3f (1,0,0)
    glVertex3f (0,0,0)
    glColor3f (0,1,0)
    glVertex3f (1,0,0)
    glColor3f (1,1,1)
    glVertex3f (1,1,0)
    glColor3f (0,0,1)
    glVertex3f (0,1,0)
  glEnd ()

  '' Dieses Quad ist nicht mehr sichtbar, sobald das Culling aktiv ist, da es
  '' nur von hinten sichtbar wre!
  glPopMatrix ()
  glTranslatef (1,0,0)
  glBegin (GL_QUADS)
    glColor3f (1,0,0)
    glVertex3f (0,0,0)

    glColor3f (1,1,0)
    glVertex3f (0,1,0)

    glColor3f (1,1,1)
    glVertex3f (1,1,0)

    glColor3f (0,0,1)
    glVertex3f (1,0,0)
  glEnd ()
  
  glPopMatrix ()
End Sub
