/' Program: TerrainFade.bas '/
#lang "fb"

/'
********************[ Delphi OpenGL Template fr die Win-Api ]******************

Mit Hilfe einer Blend-Map blenden wir zwei Texturen ineinander.

Happy coding!
     Lithander (lithander@gmx.de)

****************************[Version 1.0 22.05.2001]****************************
'/

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Const _
  WND_TITLE = "OpenGL Sample"

Type _
  TTerrainFade Extends TGLBase3D
    Private :
      As TGLTextures Tex
      As TTexture gras, rock, map
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TTerrainFade

  App.MainLoop ()

Constructor TTerrainFade ()
  Create (,, WND_TITLE)
  
  gras= Tex.GetID (Tex.CreateTextureFromFile ("data/gras.jpg", "gras"))
  rock= Tex.GetID (Tex.CreateTextureFromFile ("data/rock.jpg", "rock"))
  map= Tex.CreateTextureFromFile ("data/map.jpg", "map")
End Constructor

'------------------------------------------------------------------
'  Zeichnen der Szene
'------------------------------------------------------------------
Sub TTerrainFade.DrawScene ()
  glClearColor (0,0,0,0)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  '' Hier kommt der OpenGL Code rein

  glLoadIdentity ()
  glTranslatef (0,0,-5)

  glDisable (GL_BLEND)

  '' Zeichnen der Blend-Map
  glBindTexture (GL_Texture_2D, map)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  '' Zeichnen der Stein-Textur unter Verwendung, der darunter liegenden
  '' Blend-Map
  glEnable (GL_BLEND)
  glBlendFunc (GL_DST_COLOR, GL_SRC_COLOR)
  glBindTexture (GL_TEXTURE_2D, rock)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  '' Zeichnen der Gras-Textur auf allen weien Bereichen des darunterliegenden
  '' Gebildes
  glBlendFunc (GL_SRC_COLOR, GL_ONE)
  glBindTexture (GL_TEXTURE_2D, gras)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()
End Sub
