/' Program: ColorBlend.bas '/
#lang "fb"

/'
********************[ Delphi OpenGL Template fr die Win-Api ]******************

Statt eines Alpha-Wertes nutzen wir diesmal als Blend-Faktor die Farben
der Texturen.

Happy coding!
     Lithander (lithander@gmx.de)

****************************[Version 1.0 22.05.2001]****************************
'/

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Const _
  WND_TITLE = "OpenGL Sample"

Type _
  TColorBlend Extends TGLBase3D
    Private :
      As TGLTextures Tex
      As TTexture gras, rock
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TColorBlend

  App.MainLoop ()

Constructor TColorBlend ()
  Create (,, WND_TITLE)

  gras= Tex.GetID (Tex.CreateTextureFromFile ("data/gras.jpg", "gras"))
  rock= Tex.GetID (Tex.CreateTextureFromFile ("data/rock.jpg", "rock"))
End Constructor

'------------------------------------------------------------------
'  Zeichnen der Szene
'------------------------------------------------------------------
Sub TColorBlend.DrawScene ()
  glClearColor (0,0,0,0)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  '' Hier kommt der OpenGL Code rein

  glLoadIdentity ()
  glTranslatef (0,0,-5)

  ''Blending aktivieren, Hintergrund belassen zum Pfaden Alpha-Wert nehmen
  glEnable (GL_BLEND)
  glBlendFunc (GL_SRC_COLOR, GL_ONE)
  glColor4f (1,1,1,0.5)

  glBindTexture (GL_TEXTURE_2D, rock)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  glBindTexture (GL_TEXTURE_2D, gras)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()
End Sub
