/' Program: LightMap.bas '/
#lang "fb"

/'
********************[ Delphi OpenGL Template fr die Win-Api ]******************

Wir werfen zwei unterschiedliche Lightmaps an eine Wand.

Happy coding!
     Lithander (lithander@gmx.de)

****************************[Version 1.0 22.05.2001]****************************
'/

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Const _
  WND_TITLE = "OpenGL Sample"

Type _
  TLightMap Extends TGLBase3D
    Private :
      As TGLTextures Tex
      As TTexture wall, light1, light2
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
  End Type

Dim App As TLightMap

  App.MainLoop ()

Constructor TLightMap ()
  Create (,, WND_TITLE)
  
  wall= Tex.GetID (Tex.CreateTextureFromFile ("data/wall.png", "wall"))
  light1= Tex.GetID (Tex.CreateTextureFromFile ("data/light.png", "light1"))
  light2= Tex.GetID (Tex.CreateTextureFromFile ("data/light2.png", "light2"))
End Constructor

'------------------------------------------------------------------
'  Zeichnen der Szene
'------------------------------------------------------------------
Sub TLightMap.DrawScene ()
  glClearColor (0,0,0,0)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  '' Hier kommt der OpenGL Code rein

  glLoadIdentity ()
  glTranslatef (0,0,-5)

  ''Blending aktivieren, Hintergrund belassen zum Pfaden Alpha-Wert nehmen
  glDisable (GL_BLEND)

  glColor3f (1,1,1)
  glBindTexture (GL_TEXTURE_2D, wall)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  glEnable (GL_BLEND)
  glColor3f (1,0.7,0.7) ''Rot

  glBlendFunc (GL_SRC_COLOR, GL_SRC_COLOR)
  glBindTexture (GL_TEXTURE_2D, light1)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  glBlendFunc (GL_SRC_COLOR, GL_ONE)
  glColor3f (0.3,1,0.3)
  glBindTexture (GL_TEXTURE_2D, light2)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()
End Sub
