/' Program: Masking.bas '/
#lang "fb"

/'
********************[ Delphi OpenGL Template fr die Win-Api ]******************

Mit Hilfe einer Mask kann man dafr sorgen, dass nur bestimmte Bereiche
einer Grafik angezeigt werden oder man z.B. ein Zielkreuz auf dem Bildschirm
zeichnet.

Happy coding!
     Lithander (lithander@gmx.de)

****************************[Version 1.0 22.05.2001]****************************
'/

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Const _
  WND_TITLE = "OpenGL Sample"

Type _
  TMasking Extends TGLBase3D
    Private :
      Tex As TGLTextures
      rock As TTexture
      mask As TTexture
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
      Declare Virtual Destructor
  End Type

Dim App As TMasking

  App.MainLoop ()

Constructor TMasking ()
  Create (,, WND_TITLE)

  rock= Tex.GetID (Tex.CreateTextureFromFile ("data/rock.jpg", "rock"))
  mask= Tex.GetID (Tex.CreateTextureFromFile ("data/dgl.png", "mask"))
End Constructor

'------------------------------------------------------------------
'  Zeichnen der Szene
'------------------------------------------------------------------
Sub TMasking.DrawScene ()
  glClearColor (0,0,0,0)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
  '' Hier kommt der OpenGL Code rein

  glLoadIdentity ()
  glTranslatef (0,0,-5)

  ''Blending aktivieren, Hintergrund belassen zum Pfaden Alpha-Wert nehmen
  glDisable (GL_BLEND)

  glColor3f (1,1,1)
  glBindTexture (GL_TEXTURE_2D, rock)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  glEnable (GL_BLEND)
  glBlendFunc (GL_ZERO, GL_SRC_COLOR)
  glBindTexture (GL_TEXTURE_2D, mask)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()
End Sub

Destructor TMasking ()
End Destructor
