/' Program: MovingLights.bas '/
#lang "fb"

/'
********************[ Delphi OpenGL Template fr die Win-Api ]******************

Wir blenden eine Lightmap auf einer Texture und bewegen diese per
Textur-Matrix. Mit Hilfe von glcolor3f vergeben wir die Farbe der Lichter.

Happy coding!
     Lithander (lithander@gmx.de)

****************************[Version 1.0 22.05.2001]****************************
'/

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Const _
  WND_TITLE = "OpenGL Sample"

Type _
  TMovingLights Extends TGLBase3D
    Private :
      Tex As TGLTextures
      rock As TTexture
      light As TTexture
      x As Single
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
      Declare Virtual Destructor ()
  End Type

Dim App As TMovingLights

  App.MainLoop ()

Constructor TMovingLights ()
  Create (,, WND_TITLE)

  rock= Tex.GetID (Tex.CreateTextureFromFile ("data/rock.jpg", "rock"))
  light= Tex.GetID (Tex.CreateTextureFromFile ("data/light3.png", "light"))
End Constructor

'------------------------------------------------------------------
'  Zeichnen der Szene
'------------------------------------------------------------------
Sub TMovingLights.DrawScene ()
  glClearColor (0,0,0,0)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  x= x -0.01

  glLoadIdentity ()
  glTranslatef (0,0,-5)


  ''Blending aktivieren, Hintergrund belassen zum Pfaden Alpha-Wert nehmen
  glDisable (GL_BLEND)

  '' Zeichnen der Bodentextur
  glColor3f (1,1,1)
  glBindTexture (GL_TEXTURE_2D, rock)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  '' Zeichnen der Lichter
  glEnable (GL_BLEND)
  glColor3f (1,0.7,0.7) ''red

  glBlendFunc (GL_ONE,GL_ONE)
  glBindTexture (GL_TEXTURE_2D, light)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  glMatrixMode (GL_TEXTURE)
  glLoadIdentity ()
  glTranslatef (-x,0,0)
  glMatrixMode (GL_MODELVIEW)

  glColor3f (0.2,0.2,1)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  glMatrixMode (GL_TEXTURE)
  glLoadIdentity ()
  glTranslatef (0,x,0)
  glMatrixMode (GL_MODELVIEW)

  glColor3f (0.5,1,0.5)
  glBegin (gl_Quads)
    glTexCoord2f (0,0)
    glVertex3f (-1,-1,0)
    glTexCoord2f (1,0)
    glVertex3f (1,-1,0)
    glTexCoord2f (1,1)
    glvertex3f (1,1,0)
    glTexCoord2f (0,1)
    glvertex3f (-1,1,0)
  glEnd ()

  glColor3f (1,1,1)

  glMatrixMode (GL_TEXTURE)
  glLoadIdentity ()
  glMatrixMode (GL_MODELVIEW)
End Sub

Destructor TMovingLights ()
End Destructor
