/' Program: MultiTex.bas '/
#lang "fb"
/'
********************[ Delphi OpenGL Template fr die Win-Api ]******************

Wir erzeugen mit einer Lightmap auf einer Wand einen schnen Beleuchtungs-
Effekt. In diesem Fall nutzen wir uns die zwei Texturen-Units der Grafikkarte

Happy coding!
     Lithander (lithander@gmx.de)

****************************[Version 1.0 22.05.2001]****************************
'/

#include "../../bglBase3D.bi"
#include "../../bglTextures.bi"

Const _
  WND_TITLE = "OpenGL Sample"

Type _
  TMultiTex Extends TGLBase3D
    Private :
      Tex As TGLTextures
      wall As TTexture
      light As TTexture
    Public :
      Declare Constructor ()
      Declare Sub DrawScene () Override
      Declare Virtual Destructor ()
  End Type

Dim App As TMultiTex

  App.MainLoop ()

Constructor TMultiTex ()
Dim TexUnits As glInt

  Create (,, WND_TITLE)
  
  ''init multitex
  glGetIntegerv (GL_MAX_TEXTURE_UNITS_ARB, @TexUnits)
  If(TexUnits < 2) Then
    ConsoleMsg ("No seccond Texture Unit found - Closing down!")
    End (1)
  End If

  wall= Tex.GetID (Tex.CreateTextureFromFile ("data/wall.png", "wall"))
  light= Tex.GetID (Tex.CreateTextureFromFile ("data/light2.png", "light"))
End Constructor

'------------------------------------------------------------------
'  Zeichnen der Szene
'------------------------------------------------------------------
Sub TMultiTex.DrawScene ()
  glClearColor (0,0,0,0)
  glClear (GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)

  glLoadIdentity ()
    glTranslatef (0,0,-5)

    '' Vorbereiten der ersten Textur-Unit
    glActiveTextureARB (GL_TEXTURE0_ARB)                        '' Aktivieren
    glEnable (GL_TEXTURE_2D)                                    '' Zum rendern verwenden
    glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)'' Tex-Envroiment einstellen
    glBindTexture (GL_TEXTURE_2D, wall)                         '' Texture setzen

    '' Zweite Textur-Unit konfigurieren
    glActiveTextureARB (GL_TEXTURE1_ARB)                        '' Aktivieren
    glEnable (GL_TEXTURE_2D)                                    '' Zum rendern verwenden
    glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)'' Tex-Envroiment einstellen
    glEnable(gl_BLEND)                                          '' Blending aktivieren
    glBlendFunc(GL_ONE,GL_ONE)                                  '' Einfaches Blending
    glBindTexture(GL_TEXTURE_2D, light)                         '' Texture setzen

    ''Blending aktivieren, Hintergrund belassen zum Pfaden Alpha-Wert nehmen

    '' Quad zeichnen und fr jede Unit UV-Coords manuell angeben!
    glBegin (gl_Quads)
      glMultiTexCoord2fARB (GL_TEXTURE0_ARB,0,0)
      glMultiTexCoord2fARB (GL_TEXTURE1_ARB,0,0)
      glVertex3f (-1,-1,0)

      glMultiTexCoord2fARB (GL_TEXTURE0_ARB,1,0)
      glMultiTexCoord2fARB (GL_TEXTURE1_ARB,1,0)
      glVertex3f (1,-1,0)

      glMultiTexCoord2fARB (GL_TEXTURE0_ARB,1,1)
      glMultiTexCoord2fARB (GL_TEXTURE1_ARB,1,1)
      glvertex3f (1,1,0)

      glMultiTexCoord2fARB (GL_TEXTURE0_ARB,0,1)
      glMultiTexCoord2fARB (GL_TEXTURE1_ARB,0,1)
      glvertex3f (-1,1,0)
    glEnd ()
End Sub

Destructor TMultiTex ()
  glDeleteTextures (1, @light)
  glDeleteTextures (1, @wall)
End Destructor
