/' Include: glUtils.bi '/
#pragma Once

#include Once "OpenGL.bi"
#include Once "bglTextures.bi" /' wegen PTextureInfo '/

Type _
  TPlayer Field= 1
    health_current As Integer
    health_max As Integer
    shield_current As Integer
    shield_max As Integer
    rockets_current As Integer
    rockets_max As Integer
  End Type

Type _
  TCoordsTex Field= 1
    As Integer X1, Y1, X2, Y2
  End Type

'' upgraded version
Sub PutTile (ByRef texture as TTextureInfo, ByVal index As Integer, _
             ByVal w As Integer, ByVal h As Integer, _
             ByVal x As Integer, ByVal y As Integer, ByVal z As Integer = 0)
Dim As Double cx, cy, rw, rh, horiz, vert

		index= index - 1
		horiz= Fix (texture.TexWidth/ w)
		vert= Fix (texture.TexHeight/ h)
		cx= (index Mod horiz)/ horiz
		cy= (index\ vert)/ vert
    rw = 1/ horiz
		rh = 1/ vert

    glBindTexture (GL_TEXTURE_2D, texture.TexID)
    glTranslatef (x, y, z)

	glBegin (GL_QUADS)
		glTexCoord2f (cx, 1- cy- rh)
		glVertex2i (0, h)  		''  LINKS UNTEN
		glTexCoord2f (cx+ rw, 1- cy- rh)
		glVertex2i (w, h)			'' RECHTS UNTEN
		glTexCoord2f (cx+ rw, 1- cy)
		glVertex2i (w, 0)			'' RECHTS OBEN
		glTexCoord2f (cx, 1- cy)
		glVertex2i (0, 0)			'' LINKS OBEN
	glEnd ()

  glLoadIdentity ()

End Sub

Sub PutClip (ByRef texture As TTextureInfo, _
             ByVal x As Integer, ByVal y As Integer, ByVal z As Integer = 0, _
             ByVal offset_x1 As Integer, ByVal offset_y1 As Integer, _
             ByVal offset_x2 As Integer, ByVal offset_y2 As Integer)
Dim As Integer quad_width, quad_height

  glEnable (GL_TEXTURE_2D)
  quad_width= Abs (offset_x1- offset_x2)
  quad_height= Abs (offset_y1- offset_y2)

  glBindTexture (GL_TEXTURE_2D, texture.TexID)
  glTranslatef (x,y,z)
	glBegin (GL_QUADS)
		glTexCoord2f (offset_x1/ texture.TexWidth, 1- offset_y2/ texture.TexHeight) ' links unten
		 glVertex2f  (0, quad_height)
		glTexCoord2f (offset_x2/ texture.TexWidth, 1- offset_y2/ texture.TexHeight) ' rechts unten
		 glVertex2f  (quad_width,  quad_height)
		glTexCoord2f (offset_x2/ texture.TexWidth, 1- offset_y1/ texture.TexHeight) ' rechts oben
		 glVertex2f  (quad_width, 0)
		glTexCoord2f (offset_x1/ texture.TexWidth, 1- offset_y1/ texture.TexHeight) ' links oben
		 glVertex2f  (0, 0)
	glEnd ()
  glLoadIdentity ()

End Sub

Sub PutTexture (ByRef Texture As TTextureInfo, _
                ByVal x As Integer, ByVal y As Integer, ByVal z As Integer = 0)

  glBindTexture (GL_TEXTURE_2D, texture.TexID)
  glTranslatef (x,y,z)
	glBegin (GL_QUADS)
		glTexCoord2f (0.0, 0.0) ' links unten
		glVertex3f   (0, texture.TexWidth,  0.0)
		glTexCoord2f (1.0, 0.0) ' rechts unten
		glVertex3f   (Texture.TexHeight,  texture.TexWidth,  0.0)
		glTexCoord2f (1.0, 1.0) ' rechts oben
		glVertex3f   (Texture.TexHeight, 0,  0.0)
		glTexCoord2f (0.0, 1.0) ' links oben
		glVertex3f   (0, 0,  0.0)
	glEnd
  glLoadIdentity ()
End Sub

Sub PutTextureVert (ByRef Texture As TTextureInfo, _
                    ByVal x As Integer, ByVal y As Integer, ByVal z As Integer = 0)

  glBindTexture (GL_TEXTURE_2D, texture.TexID)
  glTranslatef (x,y,z)
	glBegin (GL_QUADS)
		glTexCoord2f (0.0, 1.0) ' links oben
		glVertex3f   (0, texture.TexWidth,  0.0)
		glTexCoord2f (1.0, 1.0) ' rechts unten
		glVertex3f   (Texture.TexHeight,  texture.TexWidth,  0.0)
		glTexCoord2f (1.0, 0.0) ' rechts unten
		glVertex3f   (Texture.TexHeight, 0,  0.0)
		glTexCoord2f (0.0, 0.0) ' links unten
		glVertex3f   (0, 0,  0.0)
	glEnd
  glLoadIdentity ()

End Sub

Sub PutBox (ByVal x1 As Integer, ByVal y1 As Integer, _
            ByVal x2 As Integer, ByVal y2 As Integer, ByVal z As Integer = 0)
Dim As Integer w, h

  w= Abs (x2- x1)
  h= Abs (y2- y1)
  glTranslatef (x1,y1,z)
	glBegin (GL_QUADS)
		glVertex2i (0, h)
		glVertex2i (w, h)
		glVertex2i (w, 0)
		glVertex2i (0, 0)
	glEnd ()
  glLoadIdentity ()
End Sub

'' ###################################################################
''  Font system
'' ###################################################################
Const EmptyChar = 160 ' 16pixel dummy white space

Type _
  TFontChar Field= 1
    FWidth As Long 'Integer
    FHeight As Long 'Integer
    FLeft As Long 'Integer
    FRight As Long 'Integer
  End Type

Type _
  TFontSystem Field= 1
    Char(0 To 255) As TFontChar
    listbase As uLong 'uInteger
    texture As TTexture
    Spacing As uLong 'uInteger
    Fixed As uByte
  End Type

Dim Shared FontTex As TGLTextures

Sub FontLoad (ByRef Font As TFontSystem, ByVal SourceFile As String, ByVal DataFile As String)
Dim As Integer F, e
Dim tmp_buffer As TTextureInfo

  With Font
    'tmp_buffer = GFX_Load(SourceFile)
    'ReplaceColor(tmp_buffer, 0, RGB(255,0,255))
    '.texture = CreateTexture(tmp_buffer, TEX_NOFILTER OR TEX_MASKED)   '' Linear Texture
    tmp_buffer= FontTex.GetInfo (FontTex.CreateTextureFromFile (SourceFile, "tmp_buffer"))
    .texture = tmp_buffer.TexID

    F= FreeFile ()
    Open DataFile For Binary As F
      Get #F,, .Char()
    Close (F)
    ' ADDITION:
    ' 160th char has a fixed length regardless from his actual size: 16px
    .Char(EmptyChar).FWidth = 16
    ' END OF ADDITION

Dim cx As Double                             '' Holds Our X Character Coord
Dim cy As Double                             '' Holds Our Y Character Coord
Dim gloop As Integer                         '' Generic Loop Variable

    .listbase= glGenLists (256)                      '' Creating 256 Display Lists
    'glBindTexture GL_TEXTURE_2D, .texture      '' Select Our Font Texture
    For gloop= 0 To 255                         '' Loop Through All 256 Lists

      cx= (gloop Mod 16)/ 16.0                 '' X Position Of Current Character
      cy= (gloop\ 16)/ 16.0                     '' Y Position Of Current Character
#if 1
      glNewList (.listbase+ gloop, GL_COMPILE)        '' Start Building A List
      glBegin (GL_QUADS)                         '' Use A Quad For Each Character
      glTexCoord2f (cx, 1- cy- 0.0625) 'cx+0.0625, 1-cy-0.0625  
      glVertex2i (-8, 8)                      ''  LINKS UNTEN
      glTexCoord2f (cx+ 0.0625, 1- cy -0.0625) 'cx+0.0625, 1-cy         
      glVertex2i (8, 8)                       '' RECHTS UNTEN
      glTexCoord2f (cx+ 0.0625, 1- cy)
      glVertex2i (8, -8)                      '' RECHTS OBEN
      glTexCoord2f (cx, 1- cy) 'cx, 1-cy-0.0625         
      glVertex2i (-8, -8)                      '' LINKS OBEN
      glEnd ()                                   '' Done Building Our Quad (Character)
      glEndList ()                               '' Done Building The Display List
#endif

    Next gloop                                        '' Loop Until All 256 Are Built
  End With

End Sub

Function FontGetWidth (ByRef Font As TFontSystem, ByVal Text As String) As Integer
Dim As Integer sum, e, c
  
  sum= 0

  For e= 1 To Len (Text)
    c= Asc (Mid (Text, e, 1))
    If(Font.Fixed = 0) Then
      sum+= Font.Char(c).FWidth+ Font.Spacing
    Else
      sum+= 16
    End If
  Next e

  Return (sum)
End Function

Sub FontPrint (ByRef Font As TFontSystem, ByVal Text As String, _
               ByVal X As Integer, ByVal Y As Integer, ByVal Z As Integer = 0, _
               ByVal scale As Single = 1)

Dim As Integer i, e, c, sum = 0

  With Font       
    glEnable (GL_TEXTURE_2D)
    glBindTexture (GL_TEXTURE_2D, .texture)                         '' Select Our Font Texture
    'glDisable(GL_DEPTH_TEST)
    glListBase (.listbase)
    For i= 1 to Len (Text)			 
      c= Asc (Mid (Text, i, 1))
      glscalef (scale, scale, scale)
      glTranslated ((x/ scale)+ sum- .Char(c).FLeft+ 8, y/ scale+ 8, z) '' Position The Text (0,0 - Bottom Left)
      glCallList (c+ 1)     '' Write The Text To The Screen
      'glPopMatrix	
      glLoadIdentity ()
      If(Font.Fixed = 0) Then
        sum+= .Char(c).FWidth+ .Spacing
      Else
        sum+= 16
      End If
    Next i
	'glEnable(GL_DEPTH_TEST)
  End With			
End Sub

Sub GLPrint (ByRef Font As TFontSystem, ByVal text As String, _
             ByVal x As Integer, ByVal y As Integer, ByVal z As Integer, _
             ByVal R As Integer, ByVal G As Integer, ByVal B As Integer, _
             ByVal A As Integer = 255) 

Dim As uByte red, green, blue

  ' new!
  glBlendFunc (GL_ONE, GL_ONE_MINUS_SRC_ALPHA)
  'glBlendFunc Modes(Mode1), Modes(Mode2)
  'glBlendFunc GL_ONE, GL_ONE
  glcolor4f (0,0,0,.5)
  FontPrint (Font, Text, x+ 1, y+ 1, z)
  ' ...
  glcolor4ub (R, G, B, A)
  glBlendFunc (GL_ONE, GL_ONE_MINUS_SRC_ALPHA)
  FontPrint (Font, Text, x, y, z+ 1)      
End SUB

Sub DestroyFont (ByRef Font As TFontSystem)
  'ImageDestroy(Font.Handle)
  glDeleteLists (Font.listbase, 256)                      '' Delete All 256 Display Lists
End Sub

Sub DrawTexQuad (ByVal x As Integer, ByVal y As Integer, ByVal z As Integer, _
                 ByVal w As Integer, ByVal h As Integer)
  
  glTranslatef (x, y, z)
	glBegin (GL_QUADS)
		glTexCoord2f (0.0, 0.0)
		glVertex2i   (0, h)
		glTexCoord2f (1.0, 0.0)
		glVertex2i   (w, h)
		glTexCoord2f (1.0, 1.0)
		glVertex2i   (w, 0)
		glTexCoord2f (0.0, 1.0)
		glVertex2i   (0, 0)
	glEnd ()
  glLoadIdentity ()
End Sub
