/'  Include    : bglEvents.bi '/

#pragma Once

#include Once "fbgfx.bi"
#include Once "fbKeys.bi"

' Der NameSpace FB wird hier nicht verwendet

' ----- Typen -----
Type TEvent As FB.EVENT

' ----- Records -----

' ----- Objects -----
Type PHandleEvents As THandleEvents Ptr
Type _
  THandleEvents Extends Object
    Private :
      Event As TEvent
      Done As Boolean
      Keys(kbESCAPE To kbF12) As Boolean
      Declare Sub HandleEvent ()
    Protected :
      Declare Abstract Sub UserProc ()
     
      /' Keyboard '/
      Declare Virtual Sub HandleKeyPress   (ByRef Event As TEvent)
      Declare Virtual Sub HandleKeyRelease (ByRef Event As TEvent)
      
      /' Mouse '/
      Declare Virtual Sub HandleMouseMove (ByRef Event As TEvent)
      Declare Virtual Sub HandleMouseBtnPress (ByRef Event As TEvent, _
                                               ByVal Mx As Integer, ByVal My As Integer)
      Declare Virtual Sub HandleMouseBtnRelease (ByRef Event As TEvent, _
                                                 ByVal Mx As Integer, ByVal My As Integer)
      Declare Virtual Sub HandleMouseDblClick (ByRef Event As TEvent, _
                                               ByVal Mx As Integer, ByVal My As Integer)
      Declare Virtual Sub HandleMouseWheel (ByRef Event As TEvent)
      Declare Virtual Sub HandleMouseEnter ()
      Declare Virtual Sub HandleMouseExit ()
      Declare Virtual Sub HandleMouseHWheel (ByRef Event As TEvent)
      
      /' Window '/
      Declare Virtual Sub HandleGotFocus ()
      Declare Virtual Sub HandleLostFocus ()
      Declare Virtual Sub HandleWindowClose (ByRef Event As TEvent)
    Public :
      Declare Constructor ()
      Declare Sub MainLoop ()
      
      Declare Property Key (ByVal KeyCode As Integer) As Boolean
  End Type

' --------------------------------------------------------------------
'                             PUBLIC
' --------------------------------------------------------------------

' --- THandleEvents --------------------------------------------------
'   Constructor ()
' --------------------------------------------------------------------
Constructor THandleEvents ()
  Done= False
End Constructor

' --- THandleEvents --------------------------------------------------
'   MainLoop ()
' --------------------------------------------------------------------
Sub THandleEvents.MainLoop ()
  Do
    If ScreenEvent() Then
      HandleEvent ()
    End If
    UserProc ()
  Loop Until Done
End Sub

Property THandleEvents.Key (ByVal KeyCode As Integer) As Boolean
  If(KeyCode >= kbESCAPE) And (KeyCode <= kbF12) Then
    Return (Keys(KeyCode))
  Else
    Return (False)
  End If
End Property


' --------------------------------------------------------------------
'                             PROTETED
' --------------------------------------------------------------------

' --- THandleEvents --------------------------------------------------
'   HandleKeyPress () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents.HandleKeyPress (ByRef Event As TEvent)
  If(Event.ScanCode = kbESCAPE) Then Done= True
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleKeyRelease () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents.HandleKeyRelease (ByRef Event As TEvent)
  '' ...
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseMove () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents.HandleMouseMove (ByRef Event As TEvent)
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseBtnPress () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents.HandleMouseBtnPress (ByRef Event As TEvent, _
                                       ByVal Mx As Integer, ByVal My As Integer)
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseBtnRelease () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents. HandleMouseBtnRelease (ByRef Event As TEvent, _
                                          ByVal Mx As Integer, ByVal My As Integer)
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseDblClick () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents. HandleMouseDblClick (ByRef Event As TEvent, _
                                        ByVal Mx As Integer, ByVal My As Integer)
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseWheel () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents. HandleMouseWheel (ByRef Event As TEvent)
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseEnter () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents. HandleMouseEnter ()
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseExit () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents. HandleMouseExit ()
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleMouseHWheel () - Muss vom Nachfolger Aufgerufen werden
' --------------------------------------------------------------------
Sub THandleEvents. HandleMouseHWheel (ByRef Event As TEvent)
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleGotFocus () - Muss vom Nachfolger Aufgerufen werden.
' --------------------------------------------------------------------
Sub THandleEvents.HandleGotFocus ()
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleLostFocus () - Muss vom Nachfolger Aufgerufen werden.
' --------------------------------------------------------------------
Sub THandleEvents.HandleLostFocus ()
End Sub

' --- THandleEvents --------------------------------------------------
'   HandleWindowClose () - Muss vom Nachfolger Aufgerufen werden.
' --------------------------------------------------------------------
Sub THandleEvents.HandleWindowClose (ByRef Event As TEvent)
  Done= True
End Sub

' --------------------------------------------------------------------
'                             PRIVATE
' --------------------------------------------------------------------

' --- THandleEvents --------------------------------------------------
'   HandleEvent ()
' --------------------------------------------------------------------
Sub THandleEvents.HandleEvent ()
Dim As Integer Mx, My

  ScreenEvent(@Event)
  Select Case Event.Type
    Case FB.EVENT_KEY_PRESS
      Keys(Event.ScanCode)= True
      HandleKeyPress (Event)
    Case FB.EVENT_KEY_RELEASE
      Keys(Event.ScanCode)= False
      HandleKeyRelease (Event)
    Case FB.EVENT_MOUSE_MOVE          : HandleMouseMove     (Event)
    Case FB.EVENT_MOUSE_BUTTON_PRESS
      GetMouse (Mx, My)               : HandleMouseBtnPress (Event, Mx, My)
    Case FB.EVENT_MOUSE_BUTTON_RELEASE
      GetMouse (Mx, My)               : HandleMouseBtnRelease (Event, Mx, My)
    Case FB.EVENT_MOUSE_DOUBLE_CLICK
      GetMouse (Mx, My)               : HandleMouseDblClick (Event, Mx, My)
    Case FB.EVENT_MOUSE_WHEEL         : HandleMouseWheel (Event)
    Case FB.EVENT_MOUSE_ENTER         : HandleMouseEnter ()
    Case FB.EVENT_MOUSE_EXIT          : HandleMouseExit ()

    Case FB.EVENT_WINDOW_GOT_FOCUS    : HandleGotFocus ()
    Case FB.EVENT_WINDOW_LOST_FOCUS   : HandleLostFocus ()
    Case FB.EVENT_WINDOW_CLOSE        : HandleWindowClose   (Event)
  End Select
End Sub /' Include: fbEvents.bi '/
